import turtle
import math

# Draws n line segments.
def p_line(t, n, length, angle):
    for i in range(n):
        t.fd(length)
        t.lt(angle)

# Draws a polygon with n sides.
def polygon(t, n, length):
    angle = 360/n
    p_line(t, n, length, angle)
 
# Draws an arc with the given radius and angle.
def arc(t, r, angle):
    arc_length = 2 * math.pi * r * abs(angle) / 360
    n = int(arc_length / 4) + 1
    step_length = arc_length / n
    step_angle = float(angle) / n
 
    # Before starting reduces, making a slight left turn.
    t.lt(step_angle/2)
    p_line(t, n, step_length, step_angle)
    t.rt(step_angle/2)

# Draws a petal using two arcs.
def petal(t, r, angle):
    for i in range(2):
        arc(t, r, angle)
        t.lt(180-angle)

# Draws a flower with n petals.
def flower(t, n, r, angle, p):
    for i in range(n):
        petal(t, r, angle)
        t.lt(p/n)

# Draws a leaf and fill it.
def leaf(t, r, angle, p):
    t.begin_fill() # Begin the fill process.
    t.down()
    flower(t, 1, 40, 80, 180)
    t.end_fill()

# Now draw the flower using the helper functions

def main():
    window=turtle.Screen() #create a screen
    window.bgcolor("blue")
    lucy=turtle.Turtle()
    lucy.shape("turtle")
    lucy.color("red")
    lucy.width(5)
    lucy.speed(0)

    # Drawing flower
    flower(lucy, 10, 40, 100, 360)

    # Drawing stem
    lucy.color("brown")
    lucy.rt(90)
    lucy.fd(200)

    # Drawing leaf
    lucy.rt(270)
    lucy.color("green")
    leaf(lucy, 40, 80, 180)
    lucy.ht()

    window.exitonclick()

main()  # call the main function
